require "drummond/version"

class Drummond
  
  attr_accessor :conn, :debug

  def initialize url, debug=false, encoding=:url_encoded, adapter=Faraday.default_adapter
    @debug = debug
    @conn = Faraday.new(:url => url) do |faraday|
      faraday.request encoding 
      faraday.response :logger if @debug
      faraday.adapter adapter 
    end
  end

  def get path, params = {}, headers = {}
    self.request path, 'get', params, headers
  end

  def post path, params = {}, headers = {}
    self.request path, 'post', params, headers
  end

  def put path, params = {}, headers = {}
    self.request path, 'put', params, headers
  end

  def delete path, params = {}, headers = {}
    self.request path, 'delete', params, headers
  end

  protected

  def request path, method = 'get', params = {}, headers = {}
    res = self.conn.send(method, path) do |req|
      req.params = params
      req.headers = headers if headers.keys.size > 0
    end
    self.process res.body
  end

  def process stuff
    MultiJson.load stuff
  rescue MultiJson::LoadError => le
    stuff
  end

end
